#pragma once
#define _USE_MATH_DEFINES

#include <glm/gtx/quaternion.hpp>
#include <glm/gtc/quaternion.hpp>
#include <glm/gtc/matrix_transform.hpp>
#include <glm/gtx/norm.hpp>
#include "glut.h"
#include <math.h>


class Camera
{
private:
	glm::vec3 direction;
	glm::vec3 position;
	glm::vec3 up;

	float speed = 0.05f;
	float mouseSpeed = 0.005f;

	float horizontalAngle = (float) -M_PI/2;
	float verticalAngle = (float) -M_PI/8;

	void move(glm::vec3 relative);
	void rotate(int dx, int dy);

	//glut tracking
	glm::vec3 cameraMove;
	int lastX, lastY;

public:
	Camera();
	Camera(glm::vec3 position);
	Camera(glm::vec3 position, glm::vec3 lookAt);
	~Camera();

	void keyPressed(unsigned char key, int x, int y);
	void keyReleased(unsigned char key, int x, int y);
	void mouseButton(int button, int state, int x, int y);
	void mouseMove(int x, int y);
	void tick();



	void applyMatrix();;



};

